------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 1.8
--  \   \         Application : Virtex-6 FPGA GTX Transceiver Wizard
--  /   /         Filename : cmp_rx_buf_bypass.vhd
-- /___/   /\     Timestamp : 
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Instantiation Template
-- Generated by Xilinx Virtex-6 FPGA GTX Transceiver Wizard


--**************************Component Declarations*****************************


component CMP_RX_BUF_BYPASS 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTXRESET_SPEEDUP    : integer   := 0 -- Set to 1 to speed up sim reset
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GTX0  (X0_Y12)

    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    GTX0_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GTX0_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    GTX0_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GTX0_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    GTX0_RXBYTEISALIGNED_OUT                : out  std_logic;
    GTX0_RXCOMMADET_OUT                     : out  std_logic;
    GTX0_RXENMCOMMAALIGN_IN                 : in   std_logic;
    GTX0_RXENPCOMMAALIGN_IN                 : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    GTX0_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    GTX0_RXRECCLK_OUT                       : out  std_logic;
    GTX0_RXUSRCLK2_IN                       : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GTX0_RXN_IN                             : in   std_logic;
    GTX0_RXP_IN                             : in   std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    GTX0_RXDLYALIGNDISABLE_IN               : in   std_logic;
    GTX0_RXDLYALIGNMONENB_IN                : in   std_logic;
    GTX0_RXDLYALIGNMONITOR_OUT              : out  std_logic_vector(7 downto 0);
    GTX0_RXDLYALIGNOVERRIDE_IN              : in   std_logic;
    GTX0_RXDLYALIGNRESET_IN                 : in   std_logic;
    GTX0_RXENPMAPHASEALIGN_IN               : in   std_logic;
    GTX0_RXPMASETPHASE_IN                   : in   std_logic;
    --------------- Receive Ports - RX Loss-of-sync State Machine --------------
    GTX0_RXLOSSOFSYNC_OUT                   : out  std_logic_vector(1 downto 0);
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    GTX0_GTXRXRESET_IN                      : in   std_logic;
    GTX0_MGTREFCLKRX_IN                     : in   std_logic;
    GTX0_PLLRXRESET_IN                      : in   std_logic;
    GTX0_RXPLLLKDET_OUT                     : out  std_logic;
    GTX0_RXRESETDONE_OUT                    : out  std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GTX0_TXN_OUT                            : out  std_logic;
    GTX0_TXP_OUT                            : out  std_logic


);
end component;




component RX_SYNC 
port
(
    RXENPMAPHASEALIGN       : out std_logic;
    RXPMASETPHASE           : out std_logic;
    RXDLYALIGNDISABLE       : out std_logic;
    RXDLYALIGNRESET         : out std_logic;
    SYNC_DONE               : out std_logic;
    USER_CLK                : in  std_logic;
    RESET                   : in  std_logic
);
end component;






    ----------------------------- The GTX Wrapper -----------------------------


    cmp_rx_buf_bypass_i : CMP_RX_BUF_BYPASS
    generic map
    (
        WRAPPER_SIM_GTXRESET_SPEEDUP    =>      1
    )
    port map
    (
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GTX0  (X0Y12)

        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        GTX0_RXCHARISCOMMA_OUT          =>      ,
        GTX0_RXCHARISK_OUT              =>      ,
        GTX0_RXDISPERR_OUT              =>      ,
        GTX0_RXNOTINTABLE_OUT           =>      ,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        GTX0_RXBYTEISALIGNED_OUT        =>      ,
        GTX0_RXCOMMADET_OUT             =>      ,
        GTX0_RXENMCOMMAALIGN_IN         =>      ,
        GTX0_RXENPCOMMAALIGN_IN         =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        GTX0_RXDATA_OUT                 =>      ,
        GTX0_RXRECCLK_OUT               =>      ,
        GTX0_RXUSRCLK2_IN               =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        GTX0_RXN_IN                     =>      ,
        GTX0_RXP_IN                     =>      ,
        -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
        GTX0_RXDLYALIGNDISABLE_IN       =>      ,
        GTX0_RXDLYALIGNMONENB_IN        =>      ,
        GTX0_RXDLYALIGNMONITOR_OUT      =>      ,
        GTX0_RXDLYALIGNOVERRIDE_IN      =>      ,
        GTX0_RXDLYALIGNRESET_IN         =>      ,
        GTX0_RXENPMAPHASEALIGN_IN       =>      ,
        GTX0_RXPMASETPHASE_IN           =>      ,
        --------------- Receive Ports - RX Loss-of-sync State Machine --------------
        GTX0_RXLOSSOFSYNC_OUT           =>      ,
        ------------------------ Receive Ports - RX PLL Ports ----------------------
        GTX0_GTXRXRESET_IN              =>      ,
        GTX0_MGTREFCLKRX_IN             =>      ,
        GTX0_PLLRXRESET_IN              =>      ,
        GTX0_RXPLLLKDET_OUT             =>      ,
        GTX0_RXRESETDONE_OUT            =>      ,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GTX0_TXN_OUT                    =>      ,
        GTX0_TXP_OUT                    =>      


    );



    -----------------------Dedicated GTX Reference Clock Inputs ---------------
    -- Each dedicated refclk you are using in your design will need its own IBUFDS_GTXE1 instance
    
    q3_clk1_refclk_ibufds_i : IBUFDS_GTXE1
    port map
    (
        O                               =>      ,
        ODIV2                           =>      ,
        CEB                             =>      ,
        I                               =>      ,  -- Connect to package pin M6
        IB                              =>        -- Connect to package pin M5
    );






    ---------------------------- RXSYNC modules -------------------------------
    -- The RXSYNC module performs phase synchronization for all the active RX datapaths. It
    -- waits for the user clocks to be stable, then drives the RX phase align signals on each
    -- GTX. When phase synchronization is complete, it asserts SYNC_DONE
    
    -- Include one RX_SYNC module per Buffer bypassed RX datapath in your own design. RX_SYNC modules
    -- can also be shared, but when sharing, make sure to hold the module in reset until all lanes have 
    -- a stable clock
    
  
    
    gtx0_rxsync_i : RX_SYNC
    port map
    (
        RXENPMAPHASEALIGN               =>          
        RXPMASETPHASE                   =>      
        RXDLYALIGNDISABLE               =>      
        RXDLYALIGNRESET                 =>      
        SYNC_DONE                       =>      
        USER_CLK                        =>      
        RESET                           =>      ,
    );
    






